


<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html id="htmlId">
<head>
  <title>Coverage Report :: CommandInterpreter</title>
  <style type="text/css">
    @import "../../.css/coverage.css";
  </style>
</head>

<body>
<div class="header"></div>

<div class="content">
<div class="breadCrumbs">
    [ <a href="../../index.html">all classes</a> ]
    [ <a href="../index.html">com.dema.timeregistration.application</a> ]
</div>

<h1>Coverage Summary for Class: CommandInterpreter (com.dema.timeregistration.application)</h1>

<table class="coverageStats">
<tr>
  <th class="name">Class</th>
<th class="coverageStat 
">
  Class, %
</th>
<th class="coverageStat 
">
  Method, %
</th>
<th class="coverageStat 
">
  Line, %
</th>
</tr>
<tr>
  <td class="name">CommandInterpreter</td>
<td class="coverageStat">
  <span class="percent">
    100%
  </span>
  <span class="absValue">
    (1/ 1)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    80%
  </span>
  <span class="absValue">
    (4/ 5)
  </span>
</td>
<td class="coverageStat">
  <span class="percent">
    62.3%
  </span>
  <span class="absValue">
    (38/ 61)
  </span>
</td>
</tr>

</table>

<br/>
<br/>


<div class="sourceCode"><i>1</i>&nbsp;package com.dema.timeregistration.application;
<i>2</i>&nbsp;
<i>3</i>&nbsp;import java.util.*;
<i>4</i>&nbsp;import java.util.regex.Matcher;
<i>5</i>&nbsp;import java.util.regex.Pattern;
<i>6</i>&nbsp;import java.util.stream.Collectors;
<i>7</i>&nbsp;
<i>8</i>&nbsp;public class CommandInterpreter {
<b class="fc"><i>9</i>&nbsp;    private static final Pattern pattern = Pattern.compile(&quot;\&quot;[^\&quot;]+\&quot;|\\S+&quot;);</b>
<i>10</i>&nbsp;
<i>11</i>&nbsp;    /**
<i>12</i>&nbsp;     * Commands a referred to by their keywords, which are the key of this Map.
<i>13</i>&nbsp;     */
<i>14</i>&nbsp;    private final Map&lt;String, Command&gt; commands;
<i>15</i>&nbsp;
<b class="fc"><i>16</i>&nbsp;    public CommandInterpreter(Set&lt;Command&gt; commands) {</b>
<b class="fc"><i>17</i>&nbsp;        this.commands = commands.stream().collect(Collectors.toMap(Command::getKeyword, c -&gt; c));</b>
<b class="fc"><i>18</i>&nbsp;    }</b>
<i>19</i>&nbsp;
<i>20</i>&nbsp;    /**
<i>21</i>&nbsp;     * Reads and formats documentation for every registered command. Commands are divided into Command Groups to make it
<i>22</i>&nbsp;     * easier to find commands in the documentation. Documentation can be added in the getDocumentation() function in
<i>23</i>&nbsp;     * a command implementing the Command interface. The command can be given a command group with the getCommandGroup()
<i>24</i>&nbsp;     * function.
<i>25</i>&nbsp;     */
<i>26</i>&nbsp;    public String generateDocumentation() {
<b class="nc"><i>27</i>&nbsp;        StringBuilder sb = new StringBuilder();</b>
<i>28</i>&nbsp;
<b class="nc"><i>29</i>&nbsp;        sb.append(&quot;Commands:\n\n&quot;);</b>
<i>30</i>&nbsp;
<b class="nc"><i>31</i>&nbsp;        Map&lt;String, List&lt;Command&gt;&gt; commandGroups = commands.values()</b>
<b class="nc"><i>32</i>&nbsp;                .stream()</b>
<b class="nc"><i>33</i>&nbsp;                .collect(Collectors.groupingBy(c -&gt; c.getCommandGroup().getName()));</b>
<i>34</i>&nbsp;
<b class="nc"><i>35</i>&nbsp;        commandGroups.values().forEach(l -&gt; l.sort(Comparator.comparing(Command::getKeyword)));</b>
<i>36</i>&nbsp;
<b class="nc"><i>37</i>&nbsp;        for (Map.Entry&lt;String, List&lt;Command&gt;&gt; commandGroup : commandGroups.entrySet()) {</b>
<b class="nc"><i>38</i>&nbsp;            sb.append(&quot;Command Group &#39;&quot;).append(commandGroup.getKey()).append(&quot;&#39;:\n&quot;);</b>
<i>39</i>&nbsp;
<b class="nc"><i>40</i>&nbsp;            for (Command c : commandGroup.getValue()) {</b>
<b class="nc"><i>41</i>&nbsp;                sb.append(c.getKeyword()).append(&quot; (Parameters: &quot;);</b>
<b class="nc"><i>42</i>&nbsp;                sb.append(c.getParameters().stream().map(p -&gt; &quot;-&quot; + p.getName() + (!p.isRequired() ? &quot; (Optional)&quot; : &quot;&quot;)).collect(Collectors.joining(&quot;, &quot;)));</b>
<i>43</i>&nbsp;
<b class="nc"><i>44</i>&nbsp;                if (c.getParameters().isEmpty()) {</b>
<b class="nc"><i>45</i>&nbsp;                    sb.append(&quot;None&quot;);</b>
<i>46</i>&nbsp;                }
<i>47</i>&nbsp;
<b class="nc"><i>48</i>&nbsp;                sb.append(&quot;)\n&quot;);</b>
<i>49</i>&nbsp;
<b class="nc"><i>50</i>&nbsp;                sb.append(c.getDocumentation()).append(&quot;\n\n&quot;);</b>
<b class="nc"><i>51</i>&nbsp;            }</b>
<i>52</i>&nbsp;
<b class="nc"><i>53</i>&nbsp;            sb.append(&quot;\n&quot;);</b>
<b class="nc"><i>54</i>&nbsp;        }</b>
<i>55</i>&nbsp;
<b class="nc"><i>56</i>&nbsp;        return sb.toString();</b>
<i>57</i>&nbsp;    }
<i>58</i>&nbsp;
<i>59</i>&nbsp;    /**
<i>60</i>&nbsp;     * Splits a string in to words or quoted strings. For example:
<i>61</i>&nbsp;     * register -e mads@kahler.biz -n &quot;Mads Kahler&quot;
<i>62</i>&nbsp;     * is divided into the following parts:
<i>63</i>&nbsp;     * register
<i>64</i>&nbsp;     * -e
<i>65</i>&nbsp;     * mads@kahler.biz
<i>66</i>&nbsp;     * -n
<i>67</i>&nbsp;     * &quot;Mads Kahler&quot;
<i>68</i>&nbsp;     */
<i>69</i>&nbsp;    private List&lt;String&gt; getParts(String commandString) {
<b class="fc"><i>70</i>&nbsp;        Matcher matcher = pattern.matcher(commandString);</b>
<i>71</i>&nbsp;
<b class="fc"><i>72</i>&nbsp;        List&lt;String&gt; parts = new ArrayList&lt;&gt;();</b>
<i>73</i>&nbsp;
<b class="fc"><i>74</i>&nbsp;        while (matcher.find()) {</b>
<b class="fc"><i>75</i>&nbsp;            parts.add(matcher.group());</b>
<i>76</i>&nbsp;        }
<i>77</i>&nbsp;
<b class="fc"><i>78</i>&nbsp;        return parts;</b>
<i>79</i>&nbsp;    }
<i>80</i>&nbsp;
<i>81</i>&nbsp;    /**
<i>82</i>&nbsp;     * Parses the command keyword and parameters for a given string
<i>83</i>&nbsp;     */
<i>84</i>&nbsp;    public ParsedCommand parseCommand(String commandString) throws UnrecognizedCommandException {
<b class="fc"><i>85</i>&nbsp;        List&lt;String&gt; parts = getParts(commandString);</b>
<i>86</i>&nbsp;
<b class="fc"><i>87</i>&nbsp;        if (parts.isEmpty()) {</b>
<b class="nc"><i>88</i>&nbsp;            throw new UnrecognizedCommandException(&quot;No command was entered&quot;);</b>
<i>89</i>&nbsp;        }
<i>90</i>&nbsp;
<b class="fc"><i>91</i>&nbsp;        String keyword = parts.get(0);</b>
<i>92</i>&nbsp;
<b class="fc"><i>93</i>&nbsp;        if (!commands.containsKey(keyword)) {</b>
<b class="nc"><i>94</i>&nbsp;            throw new UnrecognizedCommandException(&quot;No command with the keyword &#39;&quot; + keyword + &quot;&#39; was found&quot;);</b>
<i>95</i>&nbsp;        }
<i>96</i>&nbsp;
<b class="fc"><i>97</i>&nbsp;        Command command = commands.get(keyword);</b>
<b class="fc"><i>98</i>&nbsp;        Map&lt;String, Parameter&gt; parameters = command.getParameters().stream().collect(Collectors.toMap(Parameter::getName, p -&gt; p));</b>
<b class="fc"><i>99</i>&nbsp;        ParsedCommand parsedCommand = new ParsedCommand(command);</b>
<i>100</i>&nbsp;
<b class="fc"><i>101</i>&nbsp;        for (int i = 1; i &lt; parts.size(); i += 2) {</b>
<b class="fc"><i>102</i>&nbsp;            String parameterName = parts.get(i);</b>
<i>103</i>&nbsp;
<b class="fc"><i>104</i>&nbsp;            if (!parameterName.startsWith(&quot;-&quot;)) {</b>
<b class="fc"><i>105</i>&nbsp;                throw new UnrecognizedCommandException(&quot;Expected parameter to start with a dash (-)&quot;);</b>
<i>106</i>&nbsp;            }
<i>107</i>&nbsp;
<b class="fc"><i>108</i>&nbsp;            parameterName = parameterName.substring(1); // Remove the dash</b>
<i>109</i>&nbsp;
<b class="fc"><i>110</i>&nbsp;            if (!parameters.containsKey(parameterName)) {</b>
<b class="nc"><i>111</i>&nbsp;                throw new UnrecognizedCommandException(&quot;The command with keyword &#39;&quot; + command.getKeyword() +</b>
<i>112</i>&nbsp;                        &quot;&#39; does not contain a definition for the parameter &#39;&quot; + parameterName + &quot;&#39;&quot;);
<i>113</i>&nbsp;            }
<i>114</i>&nbsp;
<b class="fc"><i>115</i>&nbsp;            Parameter parameter = parameters.get(parameterName);</b>
<i>116</i>&nbsp;
<b class="fc"><i>117</i>&nbsp;            if (parts.size() &lt; i + 2) {</b>
<b class="fc"><i>118</i>&nbsp;                throw new UnrecognizedCommandException(&quot;Expected value for the parameter &#39;&quot; + parameterName + &quot;&#39;&quot;);</b>
<i>119</i>&nbsp;            }
<i>120</i>&nbsp;
<b class="fc"><i>121</i>&nbsp;            String value = parts.get(i + 1);</b>
<i>122</i>&nbsp;
<b class="fc"><i>123</i>&nbsp;            if (value.startsWith(&quot;-&quot;)) {</b>
<b class="nc"><i>124</i>&nbsp;                throw new UnrecognizedCommandException(&quot;Unexpected parameter &#39;&quot; + value +</b>
<i>125</i>&nbsp;                        &quot;&#39; provided as value for parameter &#39;&quot; + parameterName + &quot;&#39;&quot;);
<i>126</i>&nbsp;            }
<i>127</i>&nbsp;
<i>128</i>&nbsp;            // Remove surrounding quotation marks if needed
<b class="fc"><i>129</i>&nbsp;            if (value.startsWith(&quot;\&quot;&quot;) &amp;&amp; value.endsWith(&quot;\&quot;&quot;)) {</b>
<b class="fc"><i>130</i>&nbsp;                value = value.substring(1, value.length() - 1);</b>
<i>131</i>&nbsp;            }
<i>132</i>&nbsp;
<b class="fc"><i>133</i>&nbsp;            parsedCommand.addParsedParameter(parameter, value);</b>
<i>134</i>&nbsp;        }
<i>135</i>&nbsp;
<b class="fc"><i>136</i>&nbsp;        Set&lt;Parameter&gt; missingParameters = parsedCommand.getMissingParamters();</b>
<i>137</i>&nbsp;
<b class="fc"><i>138</i>&nbsp;        if (!missingParameters.isEmpty()) {</b>
<b class="fc"><i>139</i>&nbsp;            throw new UnrecognizedCommandException(&quot;Missing parameters: &quot; +</b>
<b class="fc"><i>140</i>&nbsp;                    String.join(&quot;, &quot;, missingParameters</b>
<b class="fc"><i>141</i>&nbsp;                            .stream()</b>
<b class="fc"><i>142</i>&nbsp;                            .map(p -&gt; &quot;-&quot; + p.getName())</b>
<b class="fc"><i>143</i>&nbsp;                            .collect(Collectors.toSet())));</b>
<i>144</i>&nbsp;        }
<i>145</i>&nbsp;
<b class="fc"><i>146</i>&nbsp;        return parsedCommand;</b>
<i>147</i>&nbsp;    }
<i>148</i>&nbsp;}
</div>
</div>

<div class="footer">
    
    <div style="float:right;">generated on 2019-05-13 13:51</div>
</div>
</body>
</html>
